
--
-- Simple SRAM interface.
--
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity sram is
    Port (
	   reset : in std_logic;
		clk : in  STD_LOGIC;
		do : out std_logic_vector(7 downto 0);          
		di : in std_logic_vector(7 downto 0);          
		we : in std_logic; 
		en : in std_logic;
		ram_IO : INOUT std_logic_vector(7 downto 0);
		ram_ce : out std_logic;
		ram_oe : out std_logic;
		ramwe : out std_logic;
		ram_bhe : out std_logic;
		ram_ble : out std_logic
	);
end sram;

architecture Behavioral of sram is 
signal state			: std_logic_vector ( 2 downto 0);  -- statemachine fr lesen schreiben
 begin


process(clk,di,we) 
  begin	
  ram_ce <= '0';
  ram_bhe <= '1'; -- Highbyte Data SRAM
  ram_ble <= '0'; -- Lowbyte Data SRAM
  --ramwe <= not we;
  --ram_oe <= we;
  if reset ='0' 
    then state<="000";
	 ramwe <= '1';
    ram_io <= "ZZZZZZZZ";
	 elsif rising_edge(clk) then  
    case state is
	 when  "000" => --ram_io<= (others => 'Z');
	   if we='1'  then
    state<="001";
	else 
	  state<="100";
	 end if;
	 -- do<=ram_io;
      when "001" 	=> ram_io<=di;
		               ramwe <= '1';
							ram_oe <= '1';
							state <= "010";
							
		when "010"  => ramwe <='0';
		               ram_io<=di;
		               state <="000";
							
							
		when "100" =>  ramwe <= '1';
		               ram_oe <='0';
		               ram_io<= (others => 'Z');
							state<="101";
	   when "101" =>  do<=ram_io;	
							state <= "000";
							
		when others => state 		<= "000";
		end case;			
	end if;
	end process;

end Behavioral;

